/**
 * Created by lcsoka on 31/05/16.
 */
var PoliceSinner = PoliceSinner || {};

//title screen
PoliceSinner.Game = function (gameParams) {
};
PoliceSinner.Game.prototype = {
	init: function () {
		console.log("Game init from: " + JSON.stringify(this.gameParams));

		var _this = this;
		this.cursors = null;
		var menuOpened = false;
		$('#game-overlay').off('click'); // FAKING HACK.......
		$('#exit-popup').off('click'); // FAKING HACK.......
		$('#popup-animal').off('click'); // FAKING HACK.......

		this.phaserJSON = this.game.cache.getJSON('tasks');

		$("#game-overlay").removeClass("hidden");


		// window.addEventListener('load', function() {
		// 	document.body.addEventListener('touchmove', function(e) {
		// 		if(menuOpened && (canScroll == false)){
		// 			e.preventDefault();
		// 		}
		// 	}, false);
		// }, false);

		this.categories = {
			"0": MERSZ,
			"1": SZEXPOZ,
			"2": TABU,
			"3": ALLATIHANGOK,
			"4": FELELSZ,
			"5": MERSZ,
			"6": SZEXPOZ,
			"7": TABU,
			"8": ALLATIHANGOK,
			"9": FELELSZ,
			"10": MERSZ,
			"11": SZEXPOZ,
			"12": TABU,
			"13": ALLATIHANGOK,
			"14": FELELSZ,
			"15": START,
			"16": START,
			"17": END,
			"18": END
		};

		$('body').on('click', '#game-overlay .hamburger-menu', function () {

			$("body").on("click", "#new-menu .party-btn", function () {
				$("#new-menu .slider").addClass("party");
			});

			$("body").on("click", "#new-menu .back-btn", function () {
				$("#new-menu .slider").removeClass("party");
			});

			if (menuOpened == false) {
				$("#game-overlay").addClass("hide");
				$("#game").addClass("hide");
				$("#new-menu").addClass("visible");
				// setTimeout(function(){
				// 	$("#game").addClass("hidden");
				// },300)
			} else {
				$("#game-overlay").removeClass("hide");
				$("#game").removeClass("hidden");
				$("#game").removeClass("hide");
				$("#new-menu").removeClass("visible");
			}


			menuOpened = !menuOpened;
			// showExitPopup();
			// _this.toggleBlur();
		});


		$('#exit-popup').on('click', '.action-buttons .yes', function () {
			// Vissza a menübe...
			$("#game-overlay").addClass("hidden");
			$("#menu").removeClass("hidden");
			hidePopup();
			_this.toggleBlur();
			_this.state.start('Menu');
			resetTeamSelect();
			hideExitPopup();

		});

		$('#exit-popup').on('click', '.action-buttons .no', function () {
			hideExitPopup();
			_this.toggleBlur();
		});

		$('#popup-animal').on('click', '.action-buttons .select', function () {
			$('#popup-animal .sounds').toggleClass("hidden");
		});

		$('#popup-animal').on('click', '.play-btn', function () {
			$(this).addClass("played");
			_this.currentSound.play();
		});
	},
	create: function () {
		var _this = this;
		//background
		this.gameType = this.gameParams.type;
		this.blured = false;
		var plusHeight = 300;
		if (this.gameType == "free") {
			if(this.game.width >= 768){
				this.background = this.game.add.sprite(0, 0, 'bgFree43');
				this.background.height = this.game.height;
			} else {
				this.background = this.game.add.sprite(0, 0, 'bgFree');
				this.background.height = (this.background.height / this.background.width) * this.game.width;
			}

			this.background.width = this.game.width;
			plusHeight = 0;

			// Eltűntetjük a popupokból a pontot

			$("#popup .point-title").addClass("hidden");
			$("#popup .point").addClass("hidden");
			$("#popup-animal .point-title").addClass("hidden");
			$("#popup-animal .point").addClass("hidden");

		} else {

			if(this.game.width >= 768){
				plusHeight = 300
			} else {
				plusHeight = 150
			}

			// Ha el volt tűntetve a pont akkor visszarakjuk

			$("#popup .point-title").removeClass("hidden");
			$("#popup .point").removeClass("hidden");
			$("#popup-animal .point-title").removeClass("hidden");
			$("#popup-animal .point").removeClass("hidden");

			this.background = this.game.add.sprite(0, 0, 'bg');

			this.background.height = (this.background.height / this.background.width) * this.game.width;
			this.background.width = this.game.width;
		}
		this.originalBGWidth = this.background.width;


		// //set world dimensions
		this.game.world.setBounds(0, 0, this.background.width, this.background.height + plusHeight);
		this.game.camera.setBoundsToWorld();
		this.tiles = [];
		this.route = [];
		this.teams = [];
		this.currentTeam = 0;
		this.teamStack = [this.currentTeam];
		this.teamToFollow = this.currentTeam;
		this.usedTasks = {
			"felelsz": [],
			"mersz": [],
			"tabu": [],
			"szexpoz": [],
			"allat": []
		};
		this.finnishedTeams = 0;
		// bottom
		// this.game.camera.y = this.background.height;

		this.cursors = this.game.input.keyboard.createCursorKeys();

		this.cameraPos = new Phaser.Point(0, 0);

		this.generateMap();
		this.generatePlayers();

		this.followTeam(this.currentTeam);
		this.changeHudToCurrentTeam();


		this.beka = this.game.add.audio('beka');
		this.elefant = this.game.add.audio('elefant');
		this.kacsa = this.game.add.audio('kacsa');
		this.kutya = this.game.add.audio('kutya');
		this.lama = this.game.add.audio('lama');
		this.majom = this.game.add.audio('majom');
		this.mokus = this.game.add.audio('mokus');
		this.oroszlan = this.game.add.audio('oroszlan');
		this.pingvin = this.game.add.audio('pingvin');
		this.pulyka = this.game.add.audio('pulyka');
		this.szamar = this.game.add.audio('szamar');
		this.vizilo = this.game.add.audio('vizilo');

		this.sounds = {
			"beka": this.beka,
			"elefant": this.elefant,
			"kacsa": this.kacsa,
			"kutya": this.kutya,
			"majom": this.majom,
			"lama": this.lama,
			"mokus": this.mokus,
			"oroszlan": this.oroszlan,
			"pingvin": this.pingvin,
			"pulyka": this.pulyka,
			"szamar": this.szamar,
			"vizilo": this.vizilo
		};

		this.game.sound.setDecodedCallback([this.beka, this.elefant, this.kacsa, this.kutya, this.lama, this.majom, this.mokus, this.oroszlan, this.pingvin, this.pulyka, this.szamar, this.vizilo], this.loaded, this);

		$('#game-overlay').on('click', '.new-task', function () {
			_this.showTask();
		});
		
		if (typeof this.gameParams.onCreated === 'function') {
			this.gameParams.onCreated(this);
		}

		PoliceSinner.sleep();

	},
	loaded: function () {
		var _this = this;
		console.log("Audio Decoded...");
	},
	update: function () {

		if (this.cursors.up.isDown) {
			this.game.camera.y -= 10;
		}
		else if (this.cursors.down.isDown) {
			this.game.camera.y += 10;
		}

		if (this.cursors.left.isDown) {
			this.game.camera.x -= 4;
			this.movePlayer(0, 1);
		}
		else if (this.cursors.right.isDown) {
			this.game.camera.x += 4;
		}

		// Custom camera movement hack
		var lerp = 0.1;
		// this.teamStack.length -1 -> Az egyel ezelőttit követi
		// this.cameraPos.x += (this.teams[this.teamStack[this.teamStack.length - 1]].x - this.cameraPos.x) * lerp;
		// this.cameraPos.y += (this.teams[this.teamStack[this.teamStack.length - 1]].y - this.cameraPos.y) * lerp;
		this.cameraPos.x += (this.teams[this.teamToFollow].x - this.cameraPos.x) * lerp;
		this.cameraPos.y += (this.teams[this.teamToFollow].y - this.cameraPos.y) * lerp;

		this.game.camera.focusOnXY(this.cameraPos.x, this.cameraPos.y);

	},
	generateMap: function () {
		var map = [
			-1, 17, 18,
			7, 5, -1,
			9, -1, -1,
			6, -1, -1,
			7, 8, -1,
			-1, 5, -1,
			5, 5, -1,
			14, -1, -1,
			11, 13, 12,
			-1, -1, 10,
			-1, -1, 14,
			-1, 12, 11,
			-1, 13, -1,
			-1, 10, -1,
			3, 4, -1,
			2, -1, -1,
			1, -1, -1,
			4, 0, 0,
			-1, -1, 2,
			-1, -1, 1,
			15, 16, 0
		];

		this.route = [
			this.mapTo1D(0, 20),
			this.mapTo1D(1, 20),
			this.mapTo1D(2, 20),
			this.mapTo1D(2, 19),
			this.mapTo1D(2, 18),
			this.mapTo1D(2, 17),
			this.mapTo1D(1, 17),
			this.mapTo1D(0, 17),
			this.mapTo1D(0, 16),
			this.mapTo1D(0, 15),
			this.mapTo1D(0, 14),
			this.mapTo1D(1, 14),
			this.mapTo1D(1, 13),
			this.mapTo1D(1, 12),
			this.mapTo1D(1, 11),
			this.mapTo1D(2, 11),
			this.mapTo1D(2, 10),
			this.mapTo1D(2, 9),
			this.mapTo1D(2, 8),
			this.mapTo1D(1, 8),
			this.mapTo1D(0, 8),
			this.mapTo1D(0, 7),
			this.mapTo1D(0, 6),
			this.mapTo1D(1, 6),
			this.mapTo1D(1, 5),
			this.mapTo1D(1, 4),
			this.mapTo1D(0, 4),
			this.mapTo1D(0, 3),
			this.mapTo1D(0, 2),
			this.mapTo1D(0, 1),
			this.mapTo1D(1, 1),
			this.mapTo1D(1, 0),
			this.mapTo1D(2, 0)
		];

		// console.log(this.route);

		var originalScale = 390 / 1242;
		var tileSize = this.game.width * originalScale;
		var startPosX = this.game.width * (55 / 1242);
		var startPosY = this.background.height * (291 / 8192);
		var tilePosX = startPosX;
		var tilePosY = startPosY;
		for (var i = 0; i < map.length; i++) {
			if (i != 0 && (i % 3) == 0) {

				tilePosX = startPosX;
				tilePosY += tileSize;
			}

			if (map[i] != -1) {
				var tile = this.game.add.sprite(tilePosX, tilePosY, "gameTileSet", map[i]);
				tile.width = tileSize;
				tile.height = tileSize;
				tile.playerCount = 0;
				tile.tileType = map[i];
				if (this.gameType == "free") {
					tile.visible = false;
				}
				tile.isFakeTile = false;
				this.tiles.push(tile);
			} else {
				var tile = {};
				tile.playerCount = 0;
				tile.isFakeTile = true;
				this.tiles.push(tile);
			}
			tilePosX += tileSize;
		}

	},
	generatePlayers: function () {

		var size = this.game.width * (179 / 1242);

		var startPosX = this.tiles[this.route[0]].x;
		var startPosY = this.tiles[this.route[0]].y;
		var posX = startPosX;
		var posY = startPosY;
		for (var i = 0; i < this.gameParams.teams.length; i++) {
			var team = this.gameParams.teams[i];

			if (i != 0 && (i % 2) == 0) {
				posX = startPosX;
				posY = startPosY + size;
			}

			if (i != 0 && (i % 4) == 0) {
				posX = startPosX + 2 * size;
				posY = startPosY + size / 2;
			}

			var teamSprite = this.game.add.sprite(posX, posY, 'player' + team.teamImage);
			teamSprite.width = size;
			teamSprite.height = size;
			teamSprite.currentTile = 0;
			teamSprite.currentPlayer = true;
			teamSprite.finished = false;
			if (this.gameType == "free") {
				teamSprite.visible = false;
			}
			this.teams.push(teamSprite);

			posX += size;

		}
	},
	mapTo1D: function (x, y) {
		return x + y * 3
	},
	movePlayer: function (teamId, steps) {
		var _this = this;
		console.log("Team(" + teamId + ") moves " + steps + " step(s)");
		var team = this.teams[teamId];
		team.bringToTop();
		// console.log(team);
		var plusStep = 0;

		// Start mező
		if (team.currentTile == 0) {
			plusStep = 1;
		}

		console.log("Current Tile " + team.currentTile)

		// Ha az adott mezőn van már játékos, ennyivel kell tovább lépnie...
		// TODO: Cél még nincs lekezelve
		/*****************/
		// EZ LETT KIVÉVE
		// try {
		// 	while (this.tiles[this.route[team.currentTile + steps + plusStep]].playerCount > 0) {
		// 		plusStep++;
		// 	}
		// } catch (e) {
		//
		// }
		//
		/*****************/
		// // Reset current tile + set next tile
		// this.tiles[this.route[team.currentTile]].playerCount--;
		// this.tiles[this.route[team.currentTile + steps + plusStep]].playerCount++;


		// Megnézzük, hogy van-e játékos az adott mezőn...

		// for (var i = 0; i < this.teams.length; i++) {
		// 	if (this.teams[i].currentTile == (team.currentTile + steps + plusStep)) {
		// 		plusStep++;
		// 	}
		// }


		/*****************/
		// EZ LETT KIVÉVE
		// for (var i = team.currentTile; i < this.route.length; i++) {
		// 	var t = this.tiles[this.route[i]];
		//
		// 	// console.log(i + ". : " + t.tileType + " playerCount: " + t.playerCount);
		//
		// 	if (!t.isFakeTile && t.playerCount) {
		// 		console.log(i + " : " + t.playerCount);
		// 	}
		// }
		/*****************/

		var sumSteps = steps + plusStep;
		console.log("Ennyit kell lépni: " + sumSteps);
		toggleClick(); // Kikapcsoljuk a kattintás


		// Get tile type:
		// var taskType = this.getTypeFromId(tileToStep.tileType);

		var j = 0;
		var canMove = true;
		this.game.time.events.loop(Phaser.Timer.SECOND * 0.5, function () {
			if (canMove) {
				var currentTile = _this.tiles[_this.route[team.currentTile]];

				if (j < sumSteps) {

					if (j == 0) {
						currentTile.playerCount--;
						// console.log("Tile " + team.currentTile + "'s playerCount: " + currentTile.playerCount);
					}

					var tileToStep = _this.tiles[_this.route[team.currentTile + 1]];

					// Beért-e a célba
					if (tileToStep.tileType >= 17) {
						canMove = false;
						_this.finnishedTeams++;
						_this.teams[teamId].finished = true;
						if (_this.gameType == "all") {
							setTimeout(function () {
								if (_this.finnishedTeams == _this.teams.length) {
									_this.endGame(teamId); // TODO: nem csapat Id
								} else {
									_this.nextTeam();
								}
								toggleClick();
							}, 500);
						}
						if (_this.gameType == "winner") {
							_this.endGame(teamId);
							toggleClick();
						}
					}

					team.currentTile += 1;

					var posX = tileToStep.x + (tileToStep.width / 2) - team.width / 2;
					var posY = tileToStep.y + (tileToStep.height / 2) - team.height / 2;
					_this.game.add.tween(team.position).to({x: posX, y: posY}, 500, Phaser.Easing.Linear.InOut, true);

					// console.log("Team " + teamId + "'s current tile is : " + _this.teams[teamId].currentTile)

				} else {
					canMove = false;

					// Elértünk a végére, beállítjuk, hogy az adott mezőn játékos van
					
					currentTile.playerCount++;
					console.log("Tile " + team.currentTile + "'s playerCount: " + currentTile.playerCount);
					
					_this.arrangePlayers(team.currentTile);

					// if (currentTile.tileType >= 17) {
					// 	_this.finnishedTeams++;
					// 	team.finished = true;
					// 	if (_this.gameType == "all" || _this.finnishedTeams == _this.teams.length) {
					// 		_this.endGame(teamId); // TODO: nem csapat Id
					// 	}
					// 	if (_this.gameType == "winner") {
					// 		_this.endGame(teamId);
					// 	}
					// }

					// Még kövessük a kamerával amíg elmozdul, majd térjünk át a következőre
					// TODO: Ez csak a task után kell!!!!
					setTimeout(function () {



						_this.nextTeam();
						PoliceSinner.sleep();
						toggleClick(); // Újra engedélyezzük a kattintást
					}, 500);
				}
				j++;
			}
		}, this);


	},

	// Játékosok elrendezése egy mezőn
	arrangePlayers: function (tileId) {
		var tile = this.tiles[this.route[tileId]];
		if (tile.playerCount < 2) return;
		var angleStep = Math.PI * 2 / tile.playerCount;
		var angleSum = 0;
		for (var i = 0; i < this.teams.length; i++) {
			var team = this.teams[i];
			if (team.currentTile === tileId) {
				var posX = tile.x + (tile.width / 2) - team.width / 2 + Math.sin(angleSum) * 10;
				var posY = tile.y + (tile.height / 2) - team.height / 2 + Math.cos(angleSum) * 10;
				this.game.add.tween(team.position).to({x: posX, y: posY}, 200, Phaser.Easing.Linear.InOut, true);
				angleSum += angleStep;
			}
		}
	},

	nextTeam: function () {

		// console.log(this.currentTeam);
		// console.log(this.gameParams.teams.length);

		this.teamStack.push(this.currentTeam);

		// Beállítjuk hogy a következő körben a másik nem következik...
		// True - Boy
		// False - Girl
		this.teams[this.currentTeam].currentPlayer = !this.teams[this.currentTeam].currentPlayer;

		if (this.currentTeam == this.gameParams.teams.length - 1) {
			this.currentTeam = 0;
		} else {
			this.currentTeam++;
		}

		if (!this.teams[this.currentTeam].finished) {
			this.teamToFollow = this.currentTeam;
			this.changeHudToCurrentTeam();
		} else {
			this.nextTeam();
		}


	},
	followTeam: function (teamId) {

		if (this.gameType != "free") {
			this.cameraPos.setTo(this.teams[teamId].x, this.teams[teamId].y);
		}

		// this.game.camera.follow();
	},
	getTypeFromId: function (typeId) {
		return this.categories[typeId];
	},
	changeHudToCurrentTeam: function () {

		var isBoy = this.teams[this.currentTeam].currentPlayer;

		if (isBoy) {
			$("#game-overlay .header .top .team").removeClass("current-girl");
			$("#game-overlay .header .top .team").addClass("current-boy");
		} else {
			$("#game-overlay .header .top .team").removeClass("current-boy");
			$("#game-overlay .header .top .team").addClass("current-girl");
		}

		var teamImg = teamImages[this.gameParams.teams[this.currentTeam].teamImage];
		var boy = this.gameParams.teams[this.currentTeam].boy;
		var girl = this.gameParams.teams[this.currentTeam].girl;
		$("#game-overlay .header .top .teamImage img").attr("src", teamImg);
		$("#game-overlay .header .top .team .boy .name").html(boy);
		$("#game-overlay .header .top .team .girl .name").html(girl);
	},
	showTask: function () {

		// UNBIND FIRST!!!
		$(".action-buttons .completed").unbind("click");
		$(".action-buttons .pass").unbind("click");

		var _this = this;
		var typeName = null;
		var sex = null;
		var type = this.getTypeFromId(this.tiles[this.route[this.teams[this.currentTeam].currentTile]].animations.currentFrame.index);
		if (this.gameType == 'free') {
			type = this.game.rnd.between(0, 4);
		}

		switch (type) {
			case 0:
				typeName = "felelsz";
				break;
			case 1:
				typeName = "mersz";
				break;
			case 2:
				typeName = "szexpoz";
				break;
			case 3:
				typeName = "tabu";
				break;
			case 4:
				typeName = "allat";
				break;
			default:
				typeName = "felelsz";
				break;
		}

		if (this.teams[this.currentTeam].currentPlayer) {
			sex = "ferfi";
		} else {
			sex = "lany";
		}

		// FELELSZ, MERSZ
		if (typeName == "felelsz" || typeName == "mersz") {
			var tasks = this.phaserJSON[typeName][sex];
		} else if (typeName == "szexpoz" || typeName == "tabu" || typeName == "allat") {
			// TODO: SZEXPÓZ, TABU, ÁLLATI HANGOK
			var tasks = this.phaserJSON[typeName];
		}
		var taskNum = this.game.rnd.between(0, tasks.length);
		if (this.usedTasks[typeName].length == tasks.length) {
			console.log("All task were selected, reset table.")
			this.usedTasks[typeName] = []; // Ha az összes volt már, akkor nullázzuk
		}
		while (this.hadPreviously(typeName, taskNum)) {
			taskNum = this.game.rnd.between(0, tasks.length);
		}
		this.usedTasks[typeName].push(taskNum);


		// POPUP
		var tabus = null;
		if (typeName == "tabu") {
			tabus = [
				tasks[taskNum].tabu1,
				tasks[taskNum].tabu2,
				tasks[taskNum].tabu3,
				tasks[taskNum].tabu4,
			];
		}
		_this.toggleBlur();
		setTimeout(function () {
			if (typeName != "allat") {

				var description = _this.phaserJSON["descriptions"];
			

				popupParams(typeName,description, tasks[taskNum].text, tasks[taskNum].point, tabus);
			} else {
				if (tasks[taskNum] != undefined) {
					_this.currentSound = _this.sounds[tasks[taskNum].audio];
					console.log(tasks[taskNum].text);
					popupParamsAnimal(typeName, tasks, tasks[taskNum].point, tasks[taskNum].audio, function (correct) {
						$('#popup-animal .sounds').toggleClass("hidden");
						if (correct) {
							winTask();
						} else {
							loseTask();
						}
						$('#popup-animal .play-btn').removeClass("played");
					});
				}
			}
		}, 200);

		function winTask() {
			toggleClick();
			win(function () {
				hidePopupAnimal();
				_this.toggleBlur();
				toggleClick();
				if (_this.gameType != "free") {
					_this.movePlayer(_this.currentTeam, tasks[taskNum].point);
				} else {
					_this.nextTeam();
				}
			});
		}

		function loseTask() {
			toggleClick();
			lose(function () {
				toggleClick();
				hidePopupAnimal();
				hidePopup();
				_this.toggleBlur();
				_this.nextTeam();
			});
		}

		function completeTask() {
			$(".action-buttons .completed").unbind("click");
			toggleClick();
			complete(function () {
				hidePopup();
				_this.toggleBlur();
				toggleClick();
				if (_this.gameType != "free") {
					_this.movePlayer(_this.currentTeam, tasks[taskNum].point);
					// _this.movePlayer(_this.currentTeam, 10);
				} else {
					_this.nextTeam();
				}
			});

			$(".action-buttons .completed").bind("click", completeTask);
		}

		function passTask() {

			toggleClick();
			pass(function () {
				toggleClick();
				hidePopup();
				_this.toggleBlur();
				_this.nextTeam();
			});
			$(".action-buttons .pass").bind("click", passTask);
		}


		$(".action-buttons .completed").bind("click", completeTask);
		$(".action-buttons .pass").bind("click", passTask);
	},
	hadPreviously: function (type, id) {
		var _this = this;
		var had = false;
		for (var i = 0; i < _this.usedTasks[type].length; i++) {
			if (_this.usedTasks[type][i] == id) {
				had = true;
			}
		}

		return had;
	},
	toggleBlur: function () {
		// var filter = null;
		// if (!this.blured) {
		// 	filter = [this.blurX, this.blurY];
		// }
		// this.background.filters = filter;
		//
		// for (var i = 0; i < this.tiles.length; i++) {
		// 	this.tiles[i].filters = filter;
		// }
		//
		// for (var i = 0; i < this.teams.length; i++) {
		// 	this.teams[i].filters = filter;
		// }

		this.blured = !this.blured;
	}
	,
	endGame: function (winnerTeamId) {
		var _this = this;
		setTimeout(function () {
			var winnerTeam = _this.gameParams.teams[winnerTeamId];
			showError("Vége a játéknak!\nA nyertes csapat: " + winnerTeam.teamId + "\n(" + winnerTeam.boy + ", " + winnerTeam.girl + ")");

			$("#game-overlay").addClass("hidden");
			$("#menu").removeClass("hidden");
			hidePopup();
			_this.toggleBlur();
			_this.state.start('Menu');
			resetTeamSelect();

			OffApi.setProp("");

			// hideExitPopup();

			// console.log("END GAME, winner team" + JSON.stringify(this.gameParams.teams[winnerTeamId]));

		}, 1000)
	}
	,
	render: function () {
	},


	storeKeys: ['gameParams', 'blured', 'usedTasks', 'finnishedTeams', 'currentTeam', 'teamStack', 'teamToFollow'],
	
	serialize: function() {
		var keys = this.storeKeys;
		var obj = {};
		for (var i = 0; i < keys.length; i++) {
			obj[keys[i]] = this[keys[i]];  // clone/extend ??
		}
		// save teams' data
		obj.teams = [];
		for (var i = 0; i < this.teams.length; i++) {
			var team = this.teams[i];
			obj.teams[i] = {
				x: team.x,
				y: team.y,
				currentTile: team.currentTile,
				currentPlayer: team.currentPlayer,
				finished: team.finished
			};
		}
		return obj;
	},

	unserialize: function (obj) {
		if (!obj) return;
		// onCreated will be called at end of create()
		obj.gameParams.onCreated = function(self) {
			var keys = self.storeKeys;
			for (var i = 0; i < keys.length; i++) {
				self[keys[i]] = obj[keys[i]];  // clone/extend ??
			}
			// restore teams' data
			for (var i = 0; i < obj.teams.length; i++) {
				$.extend(self.teams[i], obj.teams[i]);
				self.tiles[self.route[self.teams[i].currentTile]].playerCount++;
			}
			self.changeHudToCurrentTeam();
		};
		$("#menu").addClass("hidden");
		this.gameParams = obj.gameParams;
		PoliceSinner.game.state.start("Game");
	}
};

