var PoliceSinner = PoliceSinner || {};

//loading the game assets
PoliceSinner.Preload = function () {
};

PoliceSinner.Preload.prototype = {
    preload: function () {
        //show loading screen
        // this.splash = this.add.sprite(this.game.world.centerX, this.game.world.centerY, 'logo');
        // this.splash.anchor.setTo(0.5);

        // this.background = this.game.add.sprite(0, 0, 'bg');

        // this.background.width = this.game.width;
        //
        // this.background.height = this.game.height;

        // this.preloadBar = this.add.sprite(this.game.world.centerX, this.game.world.centerY + 128, 'preloadbar');
        // this.preloadBar.anchor.setTo(0.5);
        //
        // this.load.setPreloadSprite(this.preloadBar);


        this.load.image('bg', 'img/game/bg.jpg');
        this.load.image('bgFree', 'img/game/bg-free.jpg');
        this.load.image('bgFree43', 'img/game/bg-free43.jpg');
        this.load.image('bgFree43', 'img/game/bg-free43.jpg');
        this.load.image('menu-bg', 'img/menu/bg.png');

        // task
        this.load.json('tasks', 'assets/tasks.json');
        // names
        this.load.json('names', 'assets/names.json');

        this.load.tilemap('map', 'assets/map.json', null, Phaser.Tilemap.TILED_JSON);

        this.load.image('gameTiles', 'img/game/tilemap_big.png');

        this.load.spritesheet("gameTileSet", "img/game/spritesheet_small.png", 205, 205, 19);

        this.load.image('player1', 'img/game/players/player1.png');
        this.load.image('player2', 'img/game/players/player2.png');
        this.load.image('player3', 'img/game/players/player3.png');
        this.load.image('player4', 'img/game/players/player4.png');
        this.load.image('player5', 'img/game/players/player5.png');

        this.load.script('filterX', 'js/phaser/plugins/BlurX.js');
        this.load.script('filterY', 'js/phaser/plugins/BlurY.js');

        this.load.audio('beka', 'audio/beka.mp3');
        this.load.audio('elefant', 'audio/elefant.mp3');
        this.load.audio('kacsa', 'audio/kacsa.mp3');
        this.load.audio('kutya', 'audio/kutya.mp3');
        this.load.audio('lama', 'audio/lama.mp3');
        this.load.audio('majom', 'audio/majom.mp3');
        this.load.audio('mokus', 'audio/mokus.mp3');
        this.load.audio('oroszlan', 'audio/oroszlan.mp3');
        this.load.audio('pingvin', 'audio/pingvin.mp3');
        this.load.audio('pulyka', 'audio/Pulyka.mp3');
        this.load.audio('szamar', 'audio/szamar.mp3');
        this.load.audio('vizilo', 'audio/Vizilo.mp3');

        // this.load.spritesheet("gameTileSet", "img/game/spritesheet2.png", 390, 390, 19)

    },
    create: function () {
        // this.state.start('LanguageSelector');
        var self = this;
        document.addEventListener("deviceready", onDeviceReady, false);

        function onDeviceReady() {
            PoliceSinner.game.state.start('Menu');
        }

    }
};

