/**
 * Created by lcsoka on 31/05/16.
 */
var PoliceSinner = PoliceSinner || {};

//title screen
PoliceSinner.Menu = function () {
};

PoliceSinner.Menu.prototype = {
	init: function () {
		OffApi.init();
		// alert("Menu init")
		var teamNum = $('.team').length;
		console.log("Menu init")
		var innerHeight = window.innerHeight
		this.phaserJSON = this.game.cache.getJSON('names');

		this.gameParams = {
			type: null,
			teams: []
		};
		var _this = this;

		$('input').on('focus', function (e) {
			e.preventDefault();
			e.stopPropagation();
			window.scrollTo(0, 0); //the second 0 marks the Y scroll pos. Setting this to i.e. 100 will push the screen up by 100px.
		});

		$(window).resize(function () {
			if (window.innerHeight < innerHeight) {
				$(".start").addClass("hidden")
				$(".new-team").addClass("hidden")
			} else {
				$(".start").removeClass("hidden")
				if (teamNum < 5) {
					$(".new-team").removeClass("hidden")
				}
			}
		});


		$('body').off('click'); // FAKING HACK.......

		function getGameParams() {
			_this.gameParams.teams = [];
			$.each($('.team .select-figure'), function (k, v) {
				var team = {
					teamId: $(v).attr('data-teamId'),
					teamImage: $(v).attr('data-current-image'),
					boy: $(v).parent().find($(".boy input")).val(),
					girl: $(v).parent().find($(".girl input")).val()
				};

				_this.gameParams.teams.push(team);
			});
		}


		$("body").on("click", "#menu .party-btn", function () {
			$("#menu .slider").addClass("party");
		});

		$("body").on("click", "#menu .back-btn", function () {
			$("#menu .slider").removeClass("party");
		});
		$("body").on("click", "#new-menu .party-btn", function () {
			$("#new-menu .slider").addClass("party");
		});

		$("body").on("click", "#new-menu .back-btn", function () {
			$("#new-menu .slider").removeClass("party");
		});


		// Team Select

		function openTeamSelect() {
			$("#team-select").removeClass("hidden");
			$("#game").addClass("hidden");
			// $("#parfumok").addClass("hidden");
			setTimeout(function () {
				$("#team-select").addClass("opened");
			}, 0)
		}

		function closeTeamSelect() {

			$("#team-select .header").addClass("remove")
			$("#game").removeClass("hidden");

			setTimeout(function () {
				$("#team-select").removeClass("opened");
			}, 300);

			setTimeout(function () {


				$("#team-select").addClass("hidden");
			}, 3000)


		}

		$("#menu .main .free, #new-menu .main .free ").click(function () {
			resetTeamSelect();
			openTeamSelect();
			_this.gameParams.type = "free";
		});

		$("#menu .party-menu .all,#new-menu .all").click(function () {
			openTeamSelect();
			_this.gameParams.type = "all";
		});

		$(".party-menu .winner").click(function () {
			openTeamSelect();
			_this.gameParams.type = "winner";
		});


		// New Team
		$('body').on('click', '#team-select .new-team', function () {
			teamNum = $('#team-select .team').length;
			if (teamNum < 5) {
				addNewTeam()
			} else {
				alert("MAX 5");
			}
		});

		$('body').on('click', '#team-select .hamburger-menu', function () {
			closeTeamSelect();
		});

		function addNewTeam() {
			var _this = this;
			if (window.cordova) {
				if (Keyboard.isVisible) {
					Keyboard.hide();
				}
			}

			var newTeam = $("#team-select .team").first().clone();
			$(newTeam).appendTo(".teams");

			teamNum++;
			$("#team-select .team").last().find($('.select-figure')).css({'background-image': "url(" + teamImages[0] + ")"})
			$("#team-select .team").last().find($('.select-figure')).attr("data-teamId", teamNum);
			$("#team-select .team").last().find($('.select-figure')).attr("data-current-image", 0);
			$("#team-select .team").last().find($('input')).val("");
			$("#team-select .team").last().find($('.delete')).removeClass("hidden");
			//

			setTimeout(function () {
				$("#team-select .team").last().css('transform', 'scale(1)');
			}, 0);

			if (teamNum == 5) {
				$('.new-team').addClass("hidden");
			}
		}

		// Team Select

		$('body').on('click', '#team-select .select-figure', function () {
			var teamId = $(this).attr("data-teamId");
			var currentImage = $(this).attr("data-current-image");
			openTeamSelector(teamId, currentImage);
		});


		$('body').on('click', '#team-select .circle-container .selected', function () {
			hideTeamSelector();
		});

		// Delete team

		$('body').on('click', '#team-select .delete', function () {
			if (window.cordova) {
				if (Keyboard.isVisible) {
					Keyboard.hide();
				}
			}

			var container = $(this).closest('.team');

			// reenable team icon
			var currentImageId = container.find('.select-figure').data('current-image');
			$(".circle-container img[data-id='" + currentImageId + "']").show();

			container.css('transform', 'scale(0)');
			setTimeout(function () {
				container.remove();
			}, 300);

			teamNum--;
			if (teamNum < 5) {
				$('.new-team').removeClass("hidden");
			}
			// reinit team id

			$.each($('.team .select-figure'), function (k, v) {
				$(v).attr('data-teamId', k + 1);
			})
		});

		// Select team icon

		$('body').on('click', '#team-select .circle-container img', function () {
			var imageId = $(this).attr('data-id');

			// hide selected icon, show previous icon
			var currentImageId = $('.circle-container').attr('data-current-image');
			$(".circle-container img[data-id='" + currentImageId + "']").show();
			$(this).hide();

			$('.circle-container').css({'background-image': "url(" + teamImages[imageId] + ")"});
			$('.circle-container').attr('data-current-image', imageId);

			hideTeamSelector();
		});


		function openTeamSelector(teamId, currentImage) {
			$('.select-overlay').show(0, function () {
				var scale = window.innerWidth / 375;  // relative to iPhone 6 width
				$('.circle-container').css({
					'transform': 'scale(' + scale + ')',
					'background-image': "url(" + teamImages[currentImage] + ")"
				}).attr({
					'data-current-team': teamId,
					'data-current-image': currentImage
				});
			});
		}

		function hideTeamSelector() {

			var currentTeam = $('.circle-container').attr('data-current-team');
			var currentImage = $('.circle-container').attr('data-current-image');

			$('.circle-container').css('transform', 'scale(0)');
			setTimeout(function () {
				$('.select-overlay').hide(0);
				$.each($('.team .select-figure'), function (k, v) {
					if ($(v).attr('data-teamId') == currentTeam) {
						$(v).css('background-image', 'url(' + teamImages[currentImage] + ')')
						$(v).attr('data-current-image', currentImage)
					}
				})
			}, 300);
		}

		function openInfo() {
			canScroll = true;
			$("#info").removeClass("hidden");
			setTimeout(function () {
				$("#info").addClass("opened");
			}, 0)

		}

		function closeInfo() {
			canScroll = false;
			$("#info").removeClass("opened");
			setTimeout(function () {
				$("#info").addClass("hidden");
			}, 300)
		}

		// Parfümök menu

		function openParfums() {
			canScroll = true;
			$("#parfumok").removeClass("hidden");
			setTimeout(function () {
				if (glideInit == false) {
					$("#Glide").glide({
						type: "slider",
						autoplay: false
					});
					glideInit = true;
				}
				$(".glide__bullets").css("z-index",1000)
				$("#parfumok").addClass("opened");
			}, 1)

		}

		function closeParfums() {
			canScroll = false;
			$("#parfumok").removeClass("opened");
			setTimeout(function () {
				// $("#parfumok").addClass("hidden");
			}, 300)
		}


		$(".main .infos").click(function () {
			openInfo();
		});

		$('body').on('click', '#info .hamburger-menu', function () {
			closeInfo();
		});

		$(".main .smells,.main #smells").click(function () {
			openParfums();
		});

		$('body').on('click', '#parfumok .hamburger-menu', function () {
			closeParfums();
		});

		$('body').on('click', '.start', function () {
			getGameParams();

			var error = false;

			// Csak poénból :))
			// TODO: Kivenni
			var boyLength = _this.phaserJSON['boy'].length;
			var girlLength = _this.phaserJSON['girl'].length;
			for (var i = 0; i < _this.gameParams.teams.length; i++) {

				// _this.gameParams.teams[i].boy = _this.phaserJSON['boy'][_this.game.rnd.between(0, boyLength)].name;
				// _this.gameParams.teams[i].girl = _this.phaserJSON['girl'][_this.game.rnd.between(0, girlLength)].name;

				if (_this.gameParams.teams[i].boy == "" || _this.gameParams.teams[i].girl == "") {
					showError("Nincs kitöltve az összes név!");
					error = true;
					break;
				}

				if (_this.gameParams.teams[i].teamImage == "0") {
					showError("Nem választottatok bábut!");
					error = true;
					break;
				}

			}

			if (!error) {
				closeTeamSelect();
				_this.game.state.states['Game'].gameParams = _this.gameParams;
				$(".slider").removeClass("party");
				$("#game-overlay").removeClass("hide");
				$("#game").removeClass("hide");
				$("#new-menu").removeClass("visible");
				_this.startActivity("Game");
				setTimeout(function () {


					resetTeamSelect();
				}, 300);
			}
		});

		$('body').on('click', '.share-btn', function () {
			console.log('SHARE');
			var options = {
				message: 'Próbáld ki te is a Police Sinner Club alkalmazást, és engedj a bűnös élvezetknek! ', // not supported on some apps (Facebook, Instagram)
				subject: 'Police Sinner', // fi. for email
				files: ['', ''], // an array of filenames either locally or remotely
				url: 'http://policesinnerclub.hu',
				chooserTitle: 'Válassz alkalmazást' // Android only, you can override the default share sheet title
			}

			var onSuccess = function (result) {
				console.log("Share completed? " + result.completed); // On Android apps mostly return false even while it's true
				console.log("Shared to app: " + result.app); // On Android result.app is currently empty. On iOS it's empty when sharing is cancelled (result.completed=false)
			};

			var onError = function (msg) {
				console.log("Sharing failed with message: " + msg);
			};

			window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
		})

		console.log(this.gameParams)

		// PoliceSinner.sleep();
	},
	create: function () {
		//show the space tile, repeated

		var _this = this;
		try {
			// alert("ASD");
			OffApi.getProp(function (item) {
				// alert(JSON.stringify(item));
				console.log("PROP");
				setTimeout(function () {
					PoliceSinner.wakeup(item.prop);
					OffApi.setProp("");
				}, 500);
			});


			var deviceOSVersion = device.version;

			var ver = parseInt(deviceOSVersion);
			if (ver <= 5) {
				// Android 5.0 alatt fusson le
				calcHack();
			}


		} catch (e) {
			//alert(e);
		}
	},
	update: function () {
		// if(this.game.input.activePointer.justPressed()) {
		//   this.game.state.start('Game');
		// }
	},
	startActivity: function (state) {
		this.game.state.start(state);
		$("#menu").addClass("hidden");
	},

	serialize: function () {
		var obj = {
			test: "menustate"
		};
		return obj;
	},

	unserialize: function (obj) {
		PoliceSinner.game.state.start("Menu");
	},

};